leetcode编程记录14 #62 Unique Paths

来源:互联网 发布:淘宝网吧二手电脑 编辑:程序博客网 时间:2024/06/01 09:23

leetcode编程记录14 #62 Unique Paths

标签(空格分隔): leetcode


这是一道很简单的动态规划的题目,题目如下:

A robot is located at the top-left corner of a m x n grid (marked ‘Start’ in the diagram below).

The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked ‘Finish’ in the diagram below).

How many possible unique paths are there?

a robot to the place

Above is a 3 x 7 grid. How many possible unique paths are there?

Note: m and n will be at most 100.

题目理解与分析:
这道题目要求我们计算出从左上角开始移动的机器人到达右下角目的地的不同的路径,因为这是一道动态规划的题目所以我们使用动态规划的思想和方法来完成这道题目,首先我们观察到,当只有一行或者一列网格的时候,机器人只有唯一的一条路径可以移动,而对于最终到达的目的地来说,机器人只能从它的左边或者上边的位置进入,所以能够达到该目的地的路径数就等于达到其左边和上边位置的路径之和,这样有了初始的状态和状态转换的方法我们就可以解决这个问题了。
设f(i,j)表示到达第i行第j列位置的不同路径数目。
当i = 1或者j = 1时,f(i,j) = 1;
当i > 1且j > 1时,f(i,j) = f(i-1,j) + f(i,j-1)。
根据状态转移方程得到的代码如下:

class Solution {public:    int uniquePaths(int m, int n) {        if (m <= 1 || n <= 1) {return 1;}        int a[m][n];        for (int i = 0; i < m; ++i) {            a[i][0] = 1;        }        for (int i = 0; i < n; ++i)        {            a[0][i] = 1;        }        for (int i = 1; i < m; ++i) {            for (int j = 1; j < n; ++j)            {                a[i][j] = a[i - 1][j] + a[i][j - 1];            }        }        return a[m - 1][n - 1];    }};
原创粉丝点击